@echo off

@REM Licensed Materials - Property of IBM
@REM 5725-G92 (C) Copyright IBM Corp. 2011, 2012 . All Rights Reserved.
@REM US Government Users Restricted Rights - Use, duplication or
@REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

@REM Usage: server.bat [status|start|stop|open-port]

if "%1" == "open-port" goto openport

@REM The server.bat script needs a Java implementation.
@REM It tries the following:
@REM   1. %JAVA_HOME%\bin\java
@REM   2. %JRE_HOME%\bin\java
@REM   3. %WLP_DEFAULT_JAVA_HOME%\bin\java
@REM   4. 'java' found in %PATH%
@REM If the user has not set any of these environment variables appropriately,
@REM set JAVA_HOME to the IBM Java implementation that comes with
@REM Installation Manager.
if defined JAVA_HOME goto javaok
if defined JRE_HOME goto javaok
if defined WLP_DEFAULT_JAVA_HOME goto javaok
for %%X in (java.exe) do (set JAVA_FOUND=%%~$PATH:X)
if defined JAVA_FOUND goto javaok
set JAVA_HOME="@IM_JAVA_HOME@"
:javaok

cd "@WAS_LIBERTY_DIR@\wlp\bin"
server.bat %1 worklightServer
goto end

:openport
ver | findstr XP > nul
if %ERRORLEVEL% == 0 goto openport_xp
@REM This is for Windows Server 2008, Windows Vista, or newer.
netsh advfirewall firewall add rule name="Worklight Server" action=allow protocol=TCP dir=in localport=@PORT@
goto end
:openport_xp
@REM This is for Windows XP.
netsh firewall add portopening TCP @PORT@ "Worklight Server"
goto end

:end
