# IBM Worklight Server installation script for WebSphere Application Server.
#
# Licensed Materials - Property of IBM
# 5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#

import glob
import os
import sys

if len(sys.argv) > 0:
	# Note: On Unix, wsadmin does not accept empty arguments.
	# Arguments that start with a minus sign are dangerous as well.
	# Therefore all arguments are prefixed with '='.

	appserver_selection                      = sys.argv[0] [1:]
	appserver_was_installdir                 = sys.argv[1] [1:]
	appserver_was_profile                    = sys.argv[2] [1:]
	appserver_was_profile_dir                = sys.argv[3] [1:]
	appserver_was_cell                       = sys.argv[4] [1:]
	appserver_was_node                       = sys.argv[5] [1:]
	appserver_was_serverInstance             = sys.argv[6] [1:]
	appserver_was_scope                      = sys.argv[7] [1:]
	appserver_was_admin_name                 = sys.argv[8] [1:]
	appserver_was_admin_password             = sys.argv[9] [1:]
	appserver_was_appcenteradmin_password    = sys.argv[10] [1:]
	database_selection                       = sys.argv[11] [1:]
	database_preinstalled                    = sys.argv[12] [1:]
	database_derby_datadir                   = sys.argv[13] [1:]
	database_db2_host                        = sys.argv[14] [1:]
	database_db2_port                        = sys.argv[15] [1:]
	database_db2_driver                      = sys.argv[16] [1:]
	database_db2_worklight_admin_name        = sys.argv[17] [1:]
	database_db2_worklight_admin_password    = sys.argv[18] [1:]
	database_mysql_host                      = sys.argv[19] [1:]
	database_mysql_port                      = sys.argv[20] [1:]
	database_mysql_driver                    = sys.argv[21] [1:]
	database_mysql_worklight_admin_name      = sys.argv[22] [1:]
	database_mysql_worklight_admin_password  = sys.argv[23] [1:]
	database_oracle_host                     = sys.argv[24] [1:]
	database_oracle_port                     = sys.argv[25] [1:]
	database_oracle_driver                   = sys.argv[26] [1:]
	database_oracle_worklight_admin_name     = sys.argv[27] [1:]
	database_oracle_worklight_admin_password = sys.argv[28] [1:]

	worklight_war                            = sys.argv[29] [1:]
	worklight_war_basename                   = sys.argv[30] [1:]
	worklight_war_context                    = sys.argv[31] [1:]
	worklight_war_appname                    = sys.argv[32] [1:]
	worklight_lib                            = sys.argv[33] [1:]
	worklight_lib_basename                   = sys.argv[34] [1:]

	appcenter_war                            = sys.argv[35] [1:]
	appcenter_war_basename                   = sys.argv[36] [1:]
	appcenter_war_context                    = sys.argv[37] [1:]
	appcenter_war_appname                    = sys.argv[38] [1:]
	derby_lib                                = sys.argv[39] [1:]
	derby_lib_basename                       = sys.argv[40] [1:]

	worklight_database_name                  = sys.argv[41] [1:]
	worklightreports_database_name           = sys.argv[42] [1:]
	appcenter_database_name                  = sys.argv[43] [1:]

	database_worklight_admin_name            = sys.argv[44] [1:]
	database_worklight_admin_password        = sys.argv[45] [1:]

	android_aapt_filename                    = sys.argv[46] [1:]

	database_derby_driverclass               = sys.argv[47] [1:]
	database_db2_uri                         = sys.argv[48] [1:]
	database_db2_driverclass                 = sys.argv[49] [1:]
	database_mysql_uri                       = sys.argv[50] [1:]
	database_mysql_driverclass               = sys.argv[51] [1:]
	database_oracle_uri                      = sys.argv[52] [1:]
	database_oracle_driverclass              = sys.argv[53] [1:]
	database_db2_driver_dir                  = sys.argv[54] [1:]

	worklight_database_schema                = sys.argv[55] [1:]
	worklightreports_database_schema         = sys.argv[56] [1:]
	appcenter_database_schema                = sys.argv[57] [1:]

	worklight_database_jdbc_url              = sys.argv[58] [1:]
	worklightreports_database_jdbc_url       = sys.argv[59] [1:]
	appcenter_database_jdbc_url              = sys.argv[60] [1:]

	worklight_database_jndi_name             = sys.argv[61] [1:]
	worklightreports_database_jndi_name      = sys.argv[62] [1:]
	appcenter_database_jndi_name             = sys.argv[63] [1:]

	appserver_resourcesdir                   = sys.argv[64] [1:]

else:
	# Settings for Bruno's testing.
	appserver_selection = 'was'
	appserver_was_installdir = '/n/java/webservers/was-8.0-express'
	appserver_was_profile = 'AppSrv01'
	appserver_was_profile_dir = '/n/java/webservers/was-8.0-express/profiles/AppSrv01'
	appserver_was_cell = 'bordeauxNode02Cell'
	appserver_was_node = 'bordeauxNode02'
	appserver_was_serverInstance = 'server1'
	appserver_was_scope = 'cell'
	appserver_was_admin_name = 'admin'
	appserver_was_admin_password = 'admin'
	appserver_was_appcenteradmin_password = 'rdeouiruwoir'
	database_selection = 'derby'
	database_preinstalled = 'false'
	database_derby_datadir = '/var/ibm/Worklight/derby'
	database_db2_host = ''
	database_db2_port = ''
	database_db2_driver = ''
	database_db2_worklight_admin_name = ''
	database_db2_worklight_admin_password = ''
	database_mysql_host = ''
	database_mysql_port = ''
	database_mysql_driver = ''
	database_mysql_worklight_admin_name = ''
	database_mysql_worklight_admin_password = ''
	database_oracle_host = ''
	database_oracle_port = ''
	database_oracle_driver = ''
	database_oracle_worklight_admin_name = ''
	database_oracle_worklight_admin_password = ''

	worklight_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/worklight.war'
	worklight_war_basename = 'worklight.war'
	worklight_war_context = '/worklight'
	worklight_war_appname = 'IBM_Worklight_Console'
	worklight_lib = 'worklight-jee-library.jar'
	worklight_lib_basename = 'worklight-jee-library.jar'

	appcenter_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/../ApplicationCenter/console/applicationcenter.war'
	appcenter_war_basename = 'applicationcenter.war'
	appcenter_war_context = '/applicationcenter'
	appcenter_war_appname = 'IBM_Application_Center'
	derby_lib = 'install/derby.jar'
	derby_lib_basename = 'derby.jar'

	worklight_database_name = 'WRKLGHT'
	worklightreports_database_name = 'WLREPORT'
	appcenter_database_name = 'APPCNTR'

	database_worklight_admin_name = 'foo'
	database_worklight_admin_password = ''

	android_aapt_filename = ''

	database_derby_driverclass = 'org.apache.derby.jdbc.EmbeddedDriver'
	database_db2_uri = ''
	database_db2_driverclass = 'com.ibm.db2.jcc.DB2Driver'
	database_mysql_uri = ''
	database_mysql_driverclass = 'com.mysql.jdbc.Driver'
	database_oracle_uri = ''
	database_oracle_driverclass = 'oracle.jdbc.OracleDriver'
	database_db2_driver_dir = '/n/home/haible/worklight/db2-svt'

	worklight_database_schema = 'WORKLIGHT'
	worklightreports_database_schema = 'WORKLIGHT'
	appcenter_database_schema = 'PUREMEAP'

	worklight_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WRKLGHT'
	worklightreports_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WLREPORT'
	appcenter_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/APPCNTR'

	worklight_database_jndi_name = 'jdbc/WorklightDS'
	worklightreports_database_jndi_name = 'jdbc/WorklightReportsDS'
	appcenter_database_jndi_name = 'jdbc/AppCenterDS'

	appserver_resourcesdir = '/n/java/webservers/was-8.0-express/optionalLibraries/IBM/Worklight/5.0'

# Jython is Python 2.1 compatible, which did not have the boolean type.
True = 1
False = 0

#--------------------------------------------
# Helper methods from wsadminlib.py - start
#--------------------------------------------

def _splitlist(s):
	"""Given a string of the form [item item item], return a list of strings, one per item."""
	if s[0] != '[' or s[-1] != ']':
		raise "Invalid string: %s" % s
	return s[1:-1].split(' ')

def _splitlines(s):
	rv = [s]
	if '\r' in s:
		rv = s.split('\r\n')
	elif '\n' in s:
		rv = s.split('\n')
	if rv[-1] == '':
		rv = rv[:-1]
	return rv

def getObjectsOfType(typename, scope = None):
	"""Return a python list of objectids of all objects of the given type in the given scope
	(another object ID, e.g. a node's object id to limit the response to objects in that node)
	Leaving scope default to None gets everything in the Cell with that type.
	ALWAYS RETURNS A LIST EVEN IF ONLY ONE OBJECT.
	"""
	m = "getObjectsOfType:"
	if scope:
		#sop(m, "AdminConfig.list(%s, %s)" % ( repr(typename), repr(scope) ) )
		return _splitlines(AdminConfig.list(typename, scope))
	else:
		#sop(m, "AdminConfig.list(%s)" % ( repr(typename) ) )
		return _splitlines(AdminConfig.list(typename))

def getObjectAttribute(objectid, attributename):
	"""Return the value of the named attribute of the config object with the given ID.
	If there's no such attribute, returns None.
	If the attribute value looks like a list, converts it to a real python list.
	TODO: handle nested "lists"
	"""
	#sop("getObjectAttribute:","AdminConfig.showAttribute(%s, %s)" % ( repr(objectid), repr(attributename) ))
	result = AdminConfig.showAttribute(objectid, attributename)
	if result != None and result.startswith("[") and result.endswith("]"):
		# List looks like "[value1 value2 value3]"
		result = _splitlist(result)
	return result

def whatEnv():
	"""Returns 'nd' if connected to a dmgr, or
	'base' if connected to an unmanaged server."""
	m = "whatEnv:"

	servers = getObjectsOfType('Server')
	for server in servers:
		servertype = getObjectAttribute(server, 'serverType')
		if servertype == 'DEPLOYMENT_MANAGER':
			return 'nd'  # we have a deployment manager
	return 'base'  # no deployment manager, must be base


def createJAAS(auth_alias, auth_username, auth_password):
	""" This method encapsulates the actions needed to create a J2C authentication data entry.

	Parameters:
		auth_alias - Alias to identify authentication entry in String format
		auth_username - Name of user in authentication entry in String format
		auth_password - User password in authentication entry in String format
	Returns:
		JAAS object
	"""
	# Check if it already exists.
	auth = _splitlines(AdminConfig.list("JAASAuthData"))
	for autItem in auth:
		if (auth_alias == AdminConfig.showAttribute(autItem, "alias")):
			print "createJAAS: The %s Resource Environment Provider already exists." % auth_alias
			return autItem  # return the object

	# Get the config id for the Cell's Security object
	cell = AdminControl.getCell()
	sec = AdminConfig.getid('/Cell:%s/Security:/' % cell)

	# Create a JAASAuthData object for authentication
	alias_attr = ["alias", auth_alias]
	desc_attr = ["description", "authentication information"]
	userid_attr = ["userId", auth_username]
	password_attr = ["password", auth_password]
	attrs = [alias_attr, desc_attr, userid_attr, password_attr]
	appauthdata = AdminConfig.create("JAASAuthData", sec, attrs)
	return appauthdata # return the object

#--------------------------------------------
# Helper methods from wsadminlib.py - finish
#--------------------------------------------

# Test whether WAS 8.0 or newer is used.
was8 = not glob.glob(appserver_was_installdir + os.sep + 'features' + os.sep + 'com.ibm.ws.osgi.applications_*') == []

# Derived variables.
if appserver_was_scope == 'cell':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/'
	scopeParam = 'Cell=' + appserver_was_cell
elif appserver_was_scope == 'node':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_node + '/'
	scopeParam = 'Node=' + appserver_was_node
else:
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_node + '/Server:' + appserver_was_serverInstance + '/'
	scopeParam = 'Server=' + appserver_was_serverInstance
scopeObject = AdminConfig.getid(scopeContainmentPath)

print 'was-install.py scope setting:'
print scopeContainmentPath
print scopeParam
print scopeObject
print AdminConfig.show(scopeObject)
print

# ======================== Configuration for Worklight ========================

# Tests whether an authentication alias with the given name exists.
def authAliasExistsBAD(name):
	try:
		return AdminTask.getAuthDataEntry(['-alias', name]) != ''
	except:
		# Note: This leaves an exception
		#   FFDC Exception:com.ibm.websphere.management.cmdframework.CommandValidationException
		#   SECJ7732E: The specified auth data entry does not exist.
		# in the server's log, but it can be ignored.
		return False
def authAliasExists(name):
	jaasAuthData = AdminUtilities.convertToList(AdminConfig.list('JAASAuthData'))
	for authEntry in jaasAuthData:
		for authAlias in AdminUtilities.convertToList(AdminConfig.showAttribute(authEntry, 'alias')):
			if authAlias == name:
				return True
	return False
# Returns the AdminConfig object for an authentication alias with the given name.
def getAuthDataEntryObject(name):
	jaasAuthData = AdminUtilities.convertToList(AdminConfig.list('JAASAuthData'))
	for authEntry in jaasAuthData:
		for authAlias in AdminUtilities.convertToList(AdminConfig.showAttribute(authEntry, 'alias')):
			if authAlias == name:
				return authEntry
	return ''

# Create the authentication alias (= credentials for a datasource).
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_7securityconfig.html
print 'was-install.py creating authentication alias...'
if database_selection == 'derby' or database_selection == 'mysql' or database_selection == 'oracle':
	authenticationAlias = ''
else:
	# By convention, alias names are displayed prefixed with the node.
	# But the prefix is not specified when it is created or looked up.
	authenticationAlias = 'Worklight' + database_selection.capitalize() + 'DatabaseCredentials'
	# If the authentication alias does not already exist, create it,
	# otherwise modify it.
	# Use AdminConfig.modify to set the password, because
	# AdminTask.createAuthDataEntry and AdminTask.modifyAuthDataEntry
	# don't support passwords that contain a '"' character.
	environ = whatEnv()
	if 'nd' == environ:
		print "Handling ND. environ=%s" % ( repr(environ))
		if not authAliasExists(authenticationAlias):
			print "Creating JAAS for ND."
			createJAAS(authenticationAlias, database_worklight_admin_name, database_worklight_admin_password)
	else:  # standalone server
		print "Handling standalone server. environ=%s" % ( repr(environ))
		if not authAliasExists(appserver_was_node + '/' + authenticationAlias):
			print "Creating JAAS for standalone server."
			AdminTask.createAuthDataEntry([
				'-alias', authenticationAlias,
				'-user', 'dummy',
				'-password', 'dummy'
			])
		authenticationAlias = appserver_was_node + '/' + authenticationAlias
	entryObject = getAuthDataEntryObject(authenticationAlias)
	if entryObject == '':
		raise "could not create authentication alias '" + authenticationAlias + "'"
	AdminConfig.modify(entryObject, [
		['userId', database_worklight_admin_name],
		['password', database_worklight_admin_password]
	])
print 'was-install.py creating authentication alias done'
print authenticationAlias
print

# Create the JDBC provider.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frdat_minreq.html

# Converts a list of filenames to classpath syntax.
# This function deals with two problems:
# 1. conversion of the filenames to slashified syntax,
# 2. when a filename contains a space, this space should not be viewed as a separator
#    between classpath elements.
def convertListToClasspath(l):
	s = ''
	for x in l:
		s += '"' + x.replace(os.sep, '/') + '"' + ' '
	if s != '':
		s = s[0:len(s)-1]
	return '[' + s + ']'

# Ensures a given JDBC provider object exists.
def ensureJDBCProvider(jdbcProviderName, description, database_selection):
	implementationClassName = ''
	if database_selection == 'derby':
		databaseType = 'Derby'
		providerType = 'Derby JDBC Provider 40'
		implementationType = 'Connection pool data source'
		implementationClassName = 'org.apache.derby.jdbc.EmbeddedConnectionPoolDataSource40' # inferred by createJDBCProvider
		classpath = [ appserver_resourcesdir + '/derby/' + derby_lib_basename ]
	elif database_selection == 'db2':
		databaseType = 'DB2'
		providerType = 'DB2 Universal JDBC Driver Provider'
		implementationType = 'Connection pool data source'
		implementationClassName = 'com.ibm.db2.jcc.DB2ConnectionPoolDataSource' # inferred by createJDBCProvider
		classpath = glob.glob(appserver_resourcesdir + '/db2/*.jar')
	elif database_selection == 'mysql':
		databaseType = 'User-defined'
		providerType = 'User-defined JDBC Provider'
		implementationType = 'User-defined'
		implementationClassName = 'com.mysql.jdbc.jdbc2.optional.MysqlConnectionPoolDataSource'
		classpath = glob.glob(appserver_resourcesdir + '/mysql/*.jar')
	elif database_selection == 'oracle':
		databaseType = 'Oracle'
		providerType = 'Oracle JDBC Driver'
		implementationType = 'Connection pool data source'
		implementationClassName = 'oracle.jdbc.pool.OracleConnectionPoolDataSource' # inferred by createJDBCProvider
		classpath = glob.glob(appserver_resourcesdir + '/oracle/*.jar')
	else:
		raise "unsupported database type"
	# If the JDBC provider does not already exist, create it,
	# otherwise modify it.
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '' and AdminConfig.showAttribute(jdbcProviderObject, 'providerType') != providerType:
		# Since 'providerType' is a read-only attribute, there is no way to change it.
		# So remove the JDBC provider.
		# AdminTask.deleteJDBCProvider was only introduced in WAS 8.0.
		if was8:
			AdminTask.deleteJDBCProvider(jdbcProviderObject)
		else:
			AdminConfig.remove(jdbcProviderObject)
		jdbcProviderObject = ''
	if jdbcProviderObject == '':
		print 'was-install.py creating JDBC provider...'
		AdminTask.createJDBCProvider([
			'-scope', scopeParam,
			'-databaseType', databaseType,
			'-providerType', providerType,
			'-implementationType', implementationType,
			'-implementationClassName', implementationClassName,
			'-classpath', convertListToClasspath(classpath),
			'-name', jdbcProviderName,
			'-description', description,
			'-isolated', 'true', # Avoid version conflicts with other JDBC providers
			'-nativePath', '' # Needed for -isolated true
		])
	else:
		# Note that the properties databaseType and implementationType are
		# not actually stored in the jdbcProviderObject.
		print 'was-install.py updating JDBC provider...'
		AdminConfig.modify(
			jdbcProviderObject,
			[
				# ADMG0014E: Attribute providerType is a read-only attribute.
				#['providerType', providerType],
				['implementationClassName', implementationClassName],
				['classpath', convertListToClasspath(classpath)],
				['name', jdbcProviderName],
				['description', description],
				['isolatedClassLoader', 'true'],
				['nativepath', '']
			]);
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	print 'was-install.py JDBC provider done'
	print AdminConfig.show(jdbcProviderObject)
	print
	return jdbcProviderObject

jdbcProviderName = 'Worklight JDBC Provider'
description = 'JDBC provider for the IBM Worklight databases'
jdbcProviderObject = ensureJDBCProvider(jdbcProviderName, description, database_selection)

# Create the datasources.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html

# Shows the contents of a J2EEResourcePropertySet object.
def showJ2EEResourcePropertySet(obj):
	for prop in AdminUtilities.convertToList(AdminConfig.showAttribute(obj, 'resourceProperties')):
		print prop
		print AdminConfig.showAttribute(prop, 'name')
		print AdminConfig.showAttribute(prop, 'value')
		print

# Finds a property with the given name in a J2EEResourcePropertySet object.
def hasJ2EEResourcePropertySetProperty(obj, name):
	for prop in AdminUtilities.convertToList(AdminConfig.showAttribute(obj, 'resourceProperties')):
		if AdminConfig.showAttribute(prop, 'name') == name:
			return prop
	return None

# Ensures a J2EEResourcePropertySet object has a given property given by (name, tipe, value).
def setJ2EEResourcePropertySetProperty(obj, name, tipe, value):
	propertyObject = hasJ2EEResourcePropertySetProperty(obj, name)
	if propertyObject == None:
		AdminConfig.create('J2EEResourceProperty', obj,
			[
				['name', name],
				['type', tipe],
				['value', value]
			])
	else:
		AdminConfig.modify(propertyObject,
			[
				['type', tipe],
				['value', value]
			])

# Ensures that a resource object (e.g. a datasource object) has the given
# custom properties as J2EEResourcePropertySet.
def ensureJ2EEResourceProperties(resourceObject, customProperties):
	j2eePropertiesObject = AdminConfig.showAttribute(resourceObject, 'propertySet')
	if j2eePropertiesObject == None:
		j2eePropertiesObject = AdminConfig.create('J2EEResourcePropertySet', resourceObject, [])
	for customProperty in customProperties:
		setJ2EEResourcePropertySetProperty(j2eePropertiesObject,
			customProperty[0], customProperty[1], customProperty[2])
	#print AdminConfig.show(j2eePropertiesObject)
	#print
	#showJ2EEResourcePropertySet(j2eePropertiesObject)

# Ensures a given datasource object exists.
def ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, authenticationAlias):
	if database_selection == 'derby':
		dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.DerbyDataStoreHelper'
		properties = [
			['databaseName', 'java.lang.String', database_derby_datadir + '/' + database_name]
		]
		customProperties = [
			['user', 'java.lang.String', worklight_database_schema],
			['password', 'java.lang.String', '']
		]
	elif database_selection == 'db2':
		dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.DB2UniversalDataStoreHelper'
		properties = [
			['driverType', 'java.lang.Integer', '4'],
			['serverName', 'java.lang.String', database_db2_host],
			['portNumber', 'java.lang.Integer', database_db2_port],
			['databaseName', 'java.lang.String', database_name]
		]
		customProperties = [
		]
	elif database_selection == 'mysql':
		dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.GenericDataStoreHelper'
		properties = [
		]
		customProperties = [
			['serverName', 'java.lang.String', database_mysql_host],
			['portNumber', 'java.lang.Integer', database_mysql_port],
			['databaseName', 'java.lang.String', database_name],
			['user', 'java.lang.String', database_worklight_admin_name],
			['password', 'java.lang.String', database_worklight_admin_password],
			['nonTransactionalDataSource', 'java.lang.Boolean', 'true'],
			# Avoid runtime errors like
			# java.sql.SQLException: Can't call rollback when autocommit=true
			# java.sql.SQLException: Error open transaction is not closed
			# See <http://docs.oracle.com/cd/E19226-01/820-7695/gbhbr/index.html>.
			['relaxAutoCommit', 'java.lang.Boolean', 'true']
		]
	elif database_selection == 'oracle':
		dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.Oracle11gDataStoreHelper'
		properties = [
			['URL', 'java.lang.String', database_jdbc_url]
		]
		customProperties = [
			#['portNumber', 'java.lang.Integer', database_oracle_port], # redundant
			#['databaseName', 'java.lang.String', database_name], # redundant
			['user', 'java.lang.String', database_worklight_admin_name],
			['password', 'java.lang.String', database_worklight_admin_password]
		]
	else:
		raise "unsupported database type"
	# If the data source does not already exist, create it,
	# otherwise modify it.
	datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
	if datasourceObject != '' and AdminConfig.showAttribute(datasourceObject, 'providerType') != AdminConfig.showAttribute(jdbcProviderObject, 'providerType'):
		# Since 'providerType' is a read-only attribute, there is no way to change it.
		# So remove the datasource.
		# AdminTask.deleteDatasource was only introduced in WAS 8.0.
		if was8:
			AdminTask.deleteDatasource(datasourceObject)
		else:
			AdminConfig.remove(datasourceObject)
		datasourceObject = ''
	if datasourceObject == '':
		print 'was-install.py creating datasource...'
		if len(properties) == 0:
			# -configureResourceProperties does not accept an empty argument:
			# "WASX8015E: Invalid option value for step configureResourceProperties"
			# -configureResourceProperties does not accept a '[]' argument:
			# java.lang.IllegalArgumentException
			# So, omit the option where there are no properties to configure.
			if authenticationAlias == '':
				AdminTask.createDatasource(
					jdbcProviderObject,
					[
						'-name', datasourceName,
						'-jndiName', jndiName,
						'-dataStoreHelperClassName', dataStoreHelperClassName,
						'-description', description
					]);
			else:
				AdminTask.createDatasource(
					jdbcProviderObject,
					[
						'-name', datasourceName,
						'-jndiName', jndiName,
						'-dataStoreHelperClassName', dataStoreHelperClassName,
						'-description', description,
						'-componentManagedAuthenticationAlias', authenticationAlias
					]);
		else:
			if authenticationAlias == '':
				AdminTask.createDatasource(
					jdbcProviderObject,
					[
						'-name', datasourceName,
						'-jndiName', jndiName,
						'-dataStoreHelperClassName', dataStoreHelperClassName,
						'-configureResourceProperties', properties,
						'-description', description
					]);
			else:
				AdminTask.createDatasource(
					jdbcProviderObject,
					[
						'-name', datasourceName,
						'-jndiName', jndiName,
						'-dataStoreHelperClassName', dataStoreHelperClassName,
						'-configureResourceProperties', properties,
						'-description', description,
						'-componentManagedAuthenticationAlias', authenticationAlias
					]);
	else:
		print 'was-install.py updating datasource...'
		AdminConfig.modify(
			datasourceObject,
			[
				['name', datasourceName],
				['jndiName', jndiName],
				['datasourceHelperClassname', dataStoreHelperClassName],
				['description', description],
				['provider', jdbcProviderObject]
				# ADMG0014E: Attribute providerType is a read-only attribute.
				#['providerType', AdminConfig.showAttribute(jdbcProviderObject, 'providerType')]
			]);
		if authenticationAlias != '':
			AdminConfig.modify(
				datasourceObject,
				[
					['authDataAlias', authenticationAlias]
				]);
		if len(properties) > 0:
			ensureJ2EEResourceProperties(datasourceObject, properties)
	print 'was-install.py modifying datasource properties...'
	datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
	ensureJ2EEResourceProperties(datasourceObject, customProperties)
	print 'was-install.py datasource done'
	print AdminConfig.show(datasourceObject)
	print
	#showJ2EEResourcePropertySet(AdminConfig.showAttribute(datasourceObject, 'propertySet'))

datasourceName = 'Worklight database'
description = 'IBM Worklight database'
jndiName = worklight_database_jndi_name
database_name = worklight_database_name
database_jdbc_url = worklight_database_jdbc_url
ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, authenticationAlias)

datasourceName = 'Worklight reports database'
description = 'IBM Worklight reports database'
jndiName = worklightreports_database_jndi_name
database_name = worklightreports_database_name
database_jdbc_url = worklightreports_database_jdbc_url
ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, authenticationAlias)

# Ensures a given shared library object exists.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_applibrary.html
def ensureSharedLibrary(sharedLibraryName, description, classpath):
	print 'was-install.py creating shared library...'
	sharedLibraryObject = AdminConfig.getid(scopeContainmentPath + 'Library:' + sharedLibraryName + '/')
	if sharedLibraryObject == '':
		AdminConfig.create('Library', scopeObject, [
			['name', sharedLibraryName],
			['description', description],
			['classPath', classpath],
			['isolatedClassLoader', 'true']
		])
	else:
		AdminConfig.modify(sharedLibraryObject, [
			['description', description],
			['classPath', classpath],
			['isolatedClassLoader', 'true']
		])
	print 'was-install.py creating shared library done'

sharedLibraryName = 'Worklight Platform Library'
description = 'IBM Worklight Server Platform Library'
classpath = appserver_resourcesdir + '/worklight-jee-library.jar'
ensureSharedLibrary(sharedLibraryName, description, classpath)

# Add system property.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atservermanagement.html
# worklight.home is needed because the Worklight server creates data and log
# files in this location. Without the system property it gets created in the
# current directory. The value must be unique for each server, so use the
# value <profileDir>/servers/<server>/worklight.home.
# Why not ".../WorklightHome" instead of ".../worklight.home"?
# 1. For consistency with the WAS Liberty and Tomcat installations, where we
#    don't set worklight.home by default. Here the directory ends up being
#    named "worklight.home".
# 2. Because in the server world, unlike in the Windows desktop world, directory
#    names are usually lower case.

# Returns the Property object that encodes the JVM system property with the given name.
def getJVMSystemPropertyObject(name):
	serverObject = AdminConfig.getid(scopeContainmentPath)
	for jvmObject in AdminUtilities.convertToList(AdminConfig.list('JavaVirtualMachine', serverObject)):
		for propertyObject in AdminUtilities.convertToList(AdminConfig.list('Property', jvmObject)):
			if name == AdminConfig.showAttribute(propertyObject, 'name'):
				return propertyObject
	return ''

# Ensures there is a JVM system property with a given value.
# If the value is '', the JVM system property setting is removed.
def ensureJVMSystemProperty(name, value):
	print 'was-install.py setting JVM system property ' + name + '...'
	# In WAS 7, invoking AdminTask.setJVMSystemProperties always creates a
	# new Property object, even if there was already one with the same name.
	propertyObject = getJVMSystemPropertyObject(name)
	if propertyObject == '':
		if value != '':
			AdminTask.setJVMSystemProperties([
				'-nodeName', appserver_was_node,
				'-serverName', appserver_was_serverInstance,
				'-propertyName', name,
				'-propertyValue', value
			])
	else:
		if value != '':
			AdminConfig.modify(propertyObject, [['value', value]])
		else:
			AdminConfig.remove(propertyObject)
	print 'was-install.py setting JVM system property ' + name + ' done'

worklight_home_dir = appserver_was_profile_dir + os.sep + 'servers' + os.sep + appserver_was_serverInstance + os.sep + 'worklight.home'
ensureJVMSystemProperty('worklight.home', worklight_home_dir)

# Add web container custom property.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frweb_custom_props.html
def ensureWebContainerCustomProperty(name, value, description):
	print 'was-install.py setting web container custom property...'
	serverObject = AdminConfig.getid(scopeContainmentPath)
	for webContainerObject in AdminUtilities.convertToList(AdminConfig.list('WebContainer', serverObject)):
		found = False
		for propertyObject in AdminUtilities.convertToList(AdminConfig.list('Property', webContainerObject)):
			if AdminConfig.showAttribute(propertyObject, 'name') == name:
				found = True
				AdminConfig.modify(propertyObject, [
					['value', value],
					['description', description]
				])
		if not found:
			AdminConfig.create('Property', webContainerObject, [
				['name', name],
				['value', value],
				['description', description]
			])
	print 'was-install.py setting web container custom property done'
# Needed as a workaround to defect 10294.
# See http://www-01.ibm.com/support/docview.wss?uid=swg1PM50111
ensureWebContainerCustomProperty('com.ibm.ws.webcontainer.invokeFlushAfterService', 'false', 'See http://www-01.ibm.com/support/docview.wss?uid=swg1PM50111')


# ==================== Configuration for ApplicationCenter ====================

datasourceName = 'Application Center database'
description = 'IBM Worklight Application Center database'
jndiName = appcenter_database_jndi_name
database_name = appcenter_database_name
database_jdbc_url = appcenter_database_jdbc_url
ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, authenticationAlias)

# Users and groups.
# Because "a user registry defined in global security is used to authenticate a user for every application in the cell.", says
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcsec_sec_multiple_domains.html
# we only add new users with hard to guess passwords.
# We *don't* add users with well-known passwords (like 'appcenteradmin' / 'admin'
# or 'demo' / 'demo'). This would be a security issue!

# Convert a string in '[ [ ... ] [ ... ] ]' syntax to a list of lists.
def convertToListList(s):
	outer = []
	if s[0] == '[' and s[len(s)-1] == ']':
		i = 1
		lbracket = s.find('[', i)
		while lbracket >= 0:
			rbracket = s.index(']', lbracket+1)
			inner = s[lbracket+1:rbracket].split(' ')
			outer.append(inner)
			i = rbracket+1
			lbracket = s.find('[', i)
	return outer

# Enable application security.
# This is only possible if administrative security is enabled, see
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_enabledisable.html
# or "you cannot enable application security without first enabling Global Security at the global level"
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcsec_sec_multiple_domains.html
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atwizardcmds.html
if AdminTask.isGlobalSecurityEnabled() == 'true':
	print 'was-install.py enabling application security...'
	# Get the previous wizard settings.
	settings = convertToListList(AdminTask.getCurrentWizardSettings())
	# Decompose them.
	secureApps = 'false'
	secureLocalResources = 'false'
	userRegistryType = 'WIMUserRegistry'
	for pair in settings:
		name = pair[0]
		value = pair[1]
		if name == 'secureApps':
			secureApps = value
		elif name == 'secureLocalResources':
			secureLocalResources = value
		elif name == 'userRegistryType':
			userRegistryType = value
	# Set secureApps to true.
	if secureApps != 'true':
		secureApps = 'true'
		AdminTask.applyWizardSettings([
			'-secureApps', secureApps,
			'-secureLocalResources', secureLocalResources,
			'-userRegistryType', userRegistryType,
			'-adminName', appserver_was_admin_name
		])
	print 'was-install.py enabling application security done'

# If the custom panels have told the user that an account 'appcenteradmin' will
# be created, do so now.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atwimmgt.html
if appserver_was_appcenteradmin_password != '':
	print 'was-install.py adding appcenteradmin user...'
	if AdminTask.searchUsers(['-uid', 'appcenteradmin']) == '':
		try:
			AdminTask.createUser([
				'-uid', 'appcenteradmin',
				'-cn', 'Administrator',
				'-sn', 'of IBM Application Center',
				'-password', appserver_was_appcenteradmin_password
			])
		except:
			# Catch exception when administrative security is not enabled:
			# "com.ibm.websphere.wim.exception.WIMApplicationException:
			# CWWIM5505E To manage users and groups, either federated repositories
			# must be the current realm definition or the current realm definition
			# configuration must match the federated repositories configuration.
			# If you use Lightweight Directory Access Protocol (LDAP), configure
			# both the federated repositories and standalone LDAP registry
			# configurations to use the same LDAP server."
			pass
	print 'was-install.py adding appcenteradmin user done'

# Add system property.
# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atservermanagement.html
if android_aapt_filename != '':
	AdminTask.setJVMSystemProperties([
		'-nodeName', appserver_was_node,
		'-serverName', appserver_was_serverInstance,
		'-propertyName', 'android.aapt',
		'-propertyValue', android_aapt_filename
	])

# Save the changes done so far.
AdminConfig.save()


# ================= Install Worklight console web application =================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_callappinstall.html
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_adminapp.html
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_taskoptions.html
# XXX If the scope is 'cell' or 'node', should we omit the '-node' and '-server' options?

print 'was-install.py installing ' + worklight_war_basename + '...'
AdminApp.install(worklight_war,
	[
		'-cell', appserver_was_cell,
		'-node', appserver_was_node,
		'-server', appserver_was_serverInstance,
		'-contextroot', worklight_war_context,
		'-appname', worklight_war_appname,
		'-MapSharedLibForMod', [[worklight_war_appname, 'META-INF/application.xml', sharedLibraryName]],
		# Avoid error "ADMA0010E: Validation error in task Selecting virtual hosts for Web modules. A virtual host is not specified"
		'-usedefaultbindings'
	]);
print 'was-install.py installing ' + worklight_war_basename + ' done'

# -------- Set classloader mode for Worklight console web application --------

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcrun_classload.html

def ensureClassLoaderModeIsParentLast(appname):
	print 'was-install.py setting classloader mode for ' + appname + '...'
	serverObject = AdminConfig.getid(scopeContainmentPath)
	# Verify that the server does not override the application-level classloader mode.
	# Keep this check consistent with the one done in the custom panels!
	applicationServerObject = AdminConfig.list('ApplicationServer', serverObject)
	if applicationServerObject != '':
		if AdminConfig.showAttribute(applicationServerObject, 'applicationClassLoaderPolicy') == 'SINGLE':
			if AdminConfig.showAttribute(applicationServerObject, 'applicationClassLoadingMode') == 'PARENT_FIRST':
				raise 'inappropriate server settings: server has applicationClassLoaderPolicy = SINGLE and applicationClassLoadingMode = PARENT_FIRST'
	deploymentObject = AdminConfig.getid('/Deployment:'+appname+'/')
	if deploymentObject != '':
		applicationDeploymentObject = AdminConfig.showAttribute(deploymentObject, 'deployedObject')
		if applicationDeploymentObject != '':
			# Set the classloader mode for the application to "Parent classloader last".
			classloaderObject = AdminConfig.showAttribute(applicationDeploymentObject, 'classloader')
			AdminConfig.modify(classloaderObject, [['mode', 'PARENT_LAST']])
			# Set the Class loader order of all modules to "Parent classloader last".
			for moduleObject in AdminUtilities.convertToList(AdminConfig.showAttribute(applicationDeploymentObject, 'modules')):
				# XXX Only if moduleObject.find('#WebModuleDeployment_') >= 0 ??
				AdminConfig.modify(moduleObject, [['classloaderMode', 'PARENT_LAST']])
	print 'was-install.py setting classloader mode for ' + appname + ' done'

ensureClassLoaderModeIsParentLast(worklight_war_appname)

# ================= Install ApplicationCenter web application =================

print 'was-install.py installing ' + appcenter_war_basename + '...'
AdminApp.install(appcenter_war,
	[
		'-cell', appserver_was_cell,
		'-node', appserver_was_node,
		'-server', appserver_was_serverInstance,
		'-contextroot', appcenter_war_context,
		'-appname', appcenter_war_appname,
		# XXX Not sure whether we need to add the appcenteradmin user name here.
		'-MapRolesToUsers', [['appcenteradmin', 'No', 'Yes', '', '']],
		# Avoid error "ADMA0010E: Validation error in task Selecting virtual hosts for Web modules. A virtual host is not specified"
		'-usedefaultbindings'
	]);
print 'was-install.py installing ' + appcenter_war_basename + ' done'

# -------- Set classloader mode for ApplicationCenter web application --------

# Without this, the ApplicationCenter web application does not start, due to
# java.lang.ClassCastException: org.jboss.resteasy.spi.ResteasyProviderFactory incompatible with javax.ws.rs.ext.RuntimeDelegate
ensureClassLoaderModeIsParentLast(appcenter_war_appname)


# Save the changes done so far.
AdminConfig.save()


# ======================== Start the web applications ========================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_startapplication.html

appManagerObject = AdminControl.queryNames('type=ApplicationManager,'
					   + 'cell=' + appserver_was_cell + ','
					   + 'node=' + appserver_was_node + ','
					   + 'process=' + appserver_was_serverInstance + ','
					   + '*')
#print appManagerObject
#print

print 'was-install.py starting ' + worklight_war_basename + '...'
AdminControl.invoke(appManagerObject, 'startApplication', worklight_war_appname)
print 'was-install.py starting ' + worklight_war_basename + ' done'

print 'was-install.py starting ' + appcenter_war_basename + '...'
AdminControl.invoke(appManagerObject, 'startApplication', appcenter_war_appname)
print 'was-install.py starting ' + appcenter_war_basename + ' done'


# ==================================== Done ===================================

# Finally save all the changes.
AdminConfig.save()
